<template>
  <div class="post-create-form">
    <hr />
    <h2>Post a reply</h2>
    <VForm
      name="post-create-form"
      :fields="fields"
      :modelState="modelState"
      buttonText="Reply"
      buttonIconClass="bi bi-save-fill"
      :busy="creating"
      busyButtonText="Replying..."
      @submit="onSubmit"
    />
  </div>
</template>

<script>
import { ref } from 'vue'
import { VForm, useApi, useNotification, useVForm } from '../../core'
import { useAuth } from '../../identity'
import PostsApi from '../api/posts-api.js'

export default {
  name: 'PostCreateForm',
  emits: ['created'],
  components: {
    VForm,
  },
  props: {
    topic: { type: Object, required: true },
  },
  setup(props, context) {
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const vform = useVForm()
    const postsApi = new PostsApi(api, auth)

    const modelState = ref({})
    const creating = ref(false)
    const fields = ref([
      {
        type: 'hidden',
        name: 'topicId',
        value: props.topic?.id || 0,
      },
      {
        type: 'markdown',
        name: 'content',
        placeholder: 'Content',
        validate: 'required',
        value: '',
      },
    ])

    const onSubmit = async (form) => {
      creating.value = true

      let response
      try {
        response = await postsApi.createAsync(form)
      } catch (ex) {
        if (ex.response.data?.modelState) {
          modelState.value = ex.response.data.modelState
        } else {
          notify.error('There was a problem creating your post.', ex)
          return
        }
      } finally {
        creating.value = false
      }

      fields.value = vform.clearValidation(fields.value)
      fields.value = vform.set(fields.value, { content: '' })
      notify.success('Post created successfully.')
      context.emit('created', response.data.id)
    }

    return {
      modelState,
      creating,
      fields,
      onSubmit,
    }
  },
}
</script>
